Loading...
Searching...
No Matches
constellation_receiver_cb.h
Go to the documentation of this file.
/* -*- c++ -*- */
/*
* Copyright 2011,2012 Free Software Foundation, Inc.
*
* This file is part of GNU Radio
*
* SPDX-License-Identifier: GPL-3.0-or-later
*
*/
#ifndef INCLUDED_DIGITAL_CONSTELLATION_RECEIVER_CB_H
#define INCLUDED_DIGITAL_CONSTELLATION_RECEIVER_CB_H
#include <gnuradio/block.h>
#include <gnuradio/blocks/control_loop.h>
#include <gnuradio/digital/api.h>
#include <gnuradio/digital/constellation.h>
namespace gr {
namespace digital {
/*!
* \brief This block makes hard decisions about the received
* symbols (using a constellation object) and also fine tunes
* phase synchronization.
*
* \details
*
* The phase and frequency synchronization are based on a Costas
* loop that finds the error of the incoming signal point compared
* to its nearest constellation point. The frequency and phase of
* the NCO are updated according to this error.
*
* Message Ports:
*
* set_constellation (input):
* Receives a PMT any containing a new gr::digital::constellation object.
* The PMT is cast back to a gr::digital::constellation_sptr
* and passes this to set_constellation.
*
* rotate_phase (input):
* Receives a PMT double to update the phase.
* The phase value passed in the message is added to the
* current phase of the receiver.
*/
class DIGITAL_API constellation_receiver_cb : virtual public block,
virtual public blocks::control_loop
{
public:
// gr::digital::constellation_receiver_cb::sptr
typedef std::shared_ptr<constellation_receiver_cb> sptr;
/*!
* \brief Constructs a constellation receiver that (phase/fine
* freq) synchronizes and decodes constellation points specified
* by a constellation object.
*
* \param constellation constellation of points for generic modulation
* \param loop_bw Loop bandwidth of the Costas Loop (~ 2pi/100)
* \param fmin minimum normalized frequency value the loop can achieve
* \param fmax maximum normalized frequency value the loop can achieve
*/
static sptr
make(constellation_sptr constellation, float loop_bw, float fmin, float fmax);
virtual void phase_error_tracking(float phase_error) = 0;
};
} /* namespace digital */
} /* namespace gr */
#endif /* INCLUDED_DIGITAL_CONSTELLATION_RECEIVER_CB_H */
gr::block::block
block(void)
Definition gnuradio-runtime/include/gnuradio/block.h:806
gr::blocks::control_loop
A second-order control loop implementation class.
Definition control_loop.h:51
gr::digital::constellation_receiver_cb
This block makes hard decisions about the received symbols (using a constellation object) and also fi...
Definition constellation_receiver_cb.h:48
gr::digital::constellation_receiver_cb::sptr
std::shared_ptr< constellation_receiver_cb > sptr
Definition constellation_receiver_cb.h:51
gr::digital::constellation_receiver_cb::make
static sptr make(constellation_sptr constellation, float loop_bw, float fmin, float fmax)
Constructs a constellation receiver that (phase/fine freq) synchronizes and decodes constellation poi...
gr::digital::constellation_receiver_cb::phase_error_tracking
virtual void phase_error_tracking(float phase_error)=0
gr::digital::constellation
An abstracted constellation object.
Definition constellation.h:50
constellation.h
control_loop.h
block.h
api.h
DIGITAL_API
#define DIGITAL_API
Definition gr-digital/include/gnuradio/digital/api.h:18
gr::digital
Definition adaptive_algorithm.h:22
gr
GNU Radio logging wrapper.
Definition basic_block.h:29